/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.232 Revision 1.285
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.232 2010/05/02 08:48:16 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.285 2013/07/15 14:04:31 ssuominen Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Original author: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
50# possible. Test ONLY for "1". 50# possible. Test ONLY for "1".
51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere. 51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52# If false, either optional deblobbing will be available 52# If false, either optional deblobbing will be available
53# or the license will note the inclusion of freedist 53# or the license will note the inclusion of freedist
54# code. 54# code.
55 55# K_LONGTERM - If set, the eclass will search for the kernel source
56# in the long term directories on the upstream servers
57# as the location has been changed by upstream
56# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 58# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
57# can be supported by the headers ebuild 59# can be supported by the headers ebuild
58 60
59# UNIPATCH_LIST - space delimetered list of patches to be applied to the 61# UNIPATCH_LIST - space delimetered list of patches to be applied to the
60# kernel 62# kernel
65# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 67# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
66# the doc dir 68# the doc dir
67# UNIPATCH_STRICTORDER - if this is set places patches into directories of 69# UNIPATCH_STRICTORDER - if this is set places patches into directories of
68# order, so they are applied in the order passed 70# order, so they are applied in the order passed
69 71
72# Changing any other variable in this eclass is not supported; you can request
73# for additional variables to be added by contacting the current maintainer.
74# If you do change them, there is a chance that we will not fix resulting bugs;
75# that of course does not mean we're not willing to help.
76
70inherit eutils toolchain-funcs versionator multilib 77inherit eutils toolchain-funcs versionator multilib
71EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst 78EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
72 79
73# Added by Daniel Ostrow <dostrow@gentoo.org> 80# Added by Daniel Ostrow <dostrow@gentoo.org>
74# This is an ugly hack to get around an issue with a 32-bit userland on ppc64. 81# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
75# I will remove it when I come up with something more reasonable. 82# I will remove it when I come up with something more reasonable.
76[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}" 83[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
79if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 86if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
80 export CTARGET=${CATEGORY/cross-} 87 export CTARGET=${CATEGORY/cross-}
81fi 88fi
82 89
83HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}" 90HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
84[[ -z ${LICENSE} ]] && \
85 LICENSE="GPL-2" 91: ${LICENSE:="GPL-2"}
86 92
87# This is the latest KV_PATCH of the deblob tool available from the 93# This is the latest KV_PATCH of the deblob tool available from the
88# libre-sources upstream. 94# libre-sources upstream. If you bump this, you MUST regenerate the Manifests
89[[ -z ${DEBLOB_MAX_VERSION} ]] && DEBLOB_MAX_VERSION=33 95# for ALL kernel-2 consumer packages where deblob is available.
96: ${DEBLOB_MAX_VERSION:=38}
90 97
91# No need to run scanelf/strip on kernel sources/headers (bug #134453). 98# No need to run scanelf/strip on kernel sources/headers (bug #134453).
92RESTRICT="binchecks strip" 99RESTRICT="binchecks strip"
93 100
94# set LINUX_HOSTCFLAGS if not already set 101# set LINUX_HOSTCFLAGS if not already set
95[[ -z ${LINUX_HOSTCFLAGS} ]] && \
96 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 102: ${LINUX_HOSTCFLAGS:="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"}
97 103
98# debugging functions 104# debugging functions
99#============================================================== 105#==============================================================
100# this function exists only to help debug kernel-2.eclass 106# this function exists only to help debug kernel-2.eclass
101# if you are adding new functionality in, put a call to it 107# if you are adding new functionality in, put a call to it
102# at the start of src_unpack, or during SRC_URI/dep generation. 108# at the start of src_unpack, or during SRC_URI/dep generation.
103debug-print-kernel2-variables() { 109debug-print-kernel2-variables() {
104 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \ 110 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
105 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \ 111 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
106 UNIPATCH_LIST S KERNEL_URI ; do 112 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
107 debug-print "${v}: ${!v}" 113 debug-print "${v}: ${!v}"
108 done 114 done
109} 115}
110 116
111#Eclass functions only from here onwards ... 117#Eclass functions only from here onwards ...
112#============================================================== 118#==============================================================
113handle_genpatches() { 119handle_genpatches() {
114 local tarball 120 local tarball
115 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1 121 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
116 122
123 debug-print "Inside handle_genpatches"
124 local OKV_ARRAY
125 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
126
127 # for > 3.0 kernels, handle genpatches tarball name
128 # genpatches for 3.0 and 3.0.1 might be named
129 # genpatches-3.0-1.base.tar.xz and genpatches-3.0-2.base.tar.xz
130 # respectively. Handle this.
131
117 for i in ${K_WANT_GENPATCHES} ; do 132 for i in ${K_WANT_GENPATCHES} ; do
133 if [[ ${KV_MAJOR} -ge 3 ]]; then
134 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
135 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.xz"
136 else
137 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.xz"
138 fi
139 else
118 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2" 140 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.xz"
141 fi
142 debug-print "genpatches tarball: $tarball"
119 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}" 143 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
120 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}" 144 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
121 done 145 done
122} 146}
123 147
124detect_version() { 148detect_version() {
125 # this function will detect and set 149 # this function will detect and set
126 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11) 150 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
127 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 151 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
128 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 152 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
129 153
130 if [[ -n ${KV_FULL} ]]; then 154 # We've already run, so nothing to do here.
131 # we will set this for backwards compatibility. 155 [[ -n ${KV_FULL} ]] && return 0
132 KV=${KV_FULL}
133
134 # we know KV_FULL so lets stop here. but not without resetting S
135 S=${WORKDIR}/linux-${KV_FULL}
136 return
137 fi
138 156
139 # CKV is used as a comparison kernel version, which is used when 157 # CKV is used as a comparison kernel version, which is used when
140 # PV doesnt reflect the genuine kernel version. 158 # PV doesnt reflect the genuine kernel version.
141 # this gets set to the portage style versioning. ie: 159 # this gets set to the portage style versioning. ie:
142 # CKV=2.6.11_rc4 160 # CKV=2.6.11_rc4
146 OKV=${OKV/_rc/-rc} 164 OKV=${OKV/_rc/-rc}
147 OKV=${OKV/-r*} 165 OKV=${OKV/-r*}
148 OKV=${OKV/_p*} 166 OKV=${OKV/_p*}
149 167
150 KV_MAJOR=$(get_version_component_range 1 ${OKV}) 168 KV_MAJOR=$(get_version_component_range 1 ${OKV})
169 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
170 local OKV_ARRAY
171 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
172
173 # if KV_MAJOR >= 3, then we have no more KV_MINOR
174 #if [[ ${KV_MAJOR} -lt 3 ]]; then
175 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
151 KV_MINOR=$(get_version_component_range 2 ${OKV}) 176 KV_MINOR=$(get_version_component_range 2 ${OKV})
152 KV_PATCH=$(get_version_component_range 3 ${OKV}) 177 KV_PATCH=$(get_version_component_range 3 ${OKV})
153
154 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then 178 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
179 KV_EXTRA=$(get_version_component_range 4- ${OKV})
180 KV_EXTRA=${KV_EXTRA/[-_]*}
181 else
182 KV_PATCH=$(get_version_component_range 3- ${OKV})
183 fi
184 else
185 KV_PATCH=$(get_version_component_range 2 ${OKV})
155 KV_EXTRA=$(get_version_component_range 4- ${OKV}) 186 KV_EXTRA=$(get_version_component_range 3- ${OKV})
156 KV_EXTRA=${KV_EXTRA/[-_]*} 187 KV_EXTRA=${KV_EXTRA/[-_]*}
188 fi
189
190 debug-print "KV_EXTRA is ${KV_EXTRA}"
191
192 KV_PATCH=${KV_PATCH/[-_]*}
193
194 local v n=0 missing
195 #if [[ ${KV_MAJOR} -lt 3 ]]; then
196 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
197 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
198 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
199 done
157 else 200 else
158 KV_PATCH=$(get_version_component_range 3- ${OKV}) 201 for v in CKV OKV KV_{MAJOR,PATCH} ; do
202 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
203 done
204 fi
205
206 [[ $n -eq 1 ]] && \
207 eerror "Missing variables: ${missing}" && \
208 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
209 unset v n missing
210
211# if [[ ${KV_MAJOR} -ge 3 ]]; then
212 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
213 KV_PATCH_ARR=(${KV_PATCH//\./ })
214
215 # at this point 031412, Linus is putting all 3.x kernels in a
216 # 3.x directory, may need to revisit when 4.x is released
217 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
218
219 [[ -n "${K_LONGTERM}" ]] &&
220 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
221 else
222 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
223 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
224 if [[ ${KV_MAJOR} -ge 3 ]]; then
225 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
226 else
227 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
159 fi 228 fi
160 KV_PATCH=${KV_PATCH/[-_]*}
161 229
162 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 230 [[ -n "${K_LONGTERM}" ]] &&
231 #KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm"
232 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
233 fi
234
235 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
236
237 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
238 # handle non genpatch using sources correctly
239 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
240 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.xz"
241 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
242 fi
243 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.xz"
244 else
245 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
246 fi
163 247
164 RELEASE=${CKV/${OKV}} 248 RELEASE=${CKV/${OKV}}
165 RELEASE=${RELEASE/_beta} 249 RELEASE=${RELEASE/_beta}
166 RELEASE=${RELEASE/_rc/-rc} 250 RELEASE=${RELEASE/_rc/-rc}
167 RELEASE=${RELEASE/_pre/-pre} 251 RELEASE=${RELEASE/_pre/-pre}
252 # We cannot trivally call kernel_is here, because it calls us to detect the
253 # version
168 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git} 254 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
255 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
169 RELEASETYPE=${RELEASE//[0-9]} 256 RELEASETYPE=${RELEASE//[0-9]}
170 257
171 # Now we know that RELEASE is the -rc/-git 258 # Now we know that RELEASE is the -rc/-git
172 # and RELEASETYPE is the same but with its numerics stripped 259 # and RELEASETYPE is the same but with its numerics stripped
173 # we can work on better sorting EXTRAVERSION. 260 # we can work on better sorting EXTRAVERSION.
174 # first of all, we add the release 261 # first of all, we add the release
175 EXTRAVERSION="${RELEASE}" 262 EXTRAVERSION="${RELEASE}"
176 debug-print "0 EXTRAVERSION:${EXTRAVERSION}" 263 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
177 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}" 264 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
178 265
179 debug-print "1 EXTRAVERSION:${EXTRAVERSION}" 266 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
180 if [[ -n "${K_NOUSEPR}" ]]; then 267 if [[ -n "${K_NOUSEPR}" ]]; then
181 # Don't add anything based on PR to EXTRAVERSION 268 # Don't add anything based on PR to EXTRAVERSION
182 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}" 269 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
200 debug-print "2 EXTRAVERSION:${EXTRAVERSION}" 287 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
201 288
202 # The only messing around which should actually effect this is for KV_EXTRA 289 # The only messing around which should actually effect this is for KV_EXTRA
203 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else 290 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
204 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION 291 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
292
205 if [[ -n ${KV_EXTRA} ]]; then 293 if [[ -n ${KV_EXTRA} ]]; then
294 if [[ -n ${KV_MINOR} ]]; then
206 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}" 295 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
207 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2 296 else
208 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2" 297 OKV="${KV_MAJOR}.${KV_PATCH}"
298 fi
299 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.xz
300 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
209 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2" 301 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
210 fi 302 fi
211 303
212 # We need to set this using OKV, but we need to set it before we do any 304 # We need to set this using OKV, but we need to set it before we do any
213 # messing around with OKV based on RELEASETYPE 305 # messing around with OKV based on RELEASETYPE
214 KV_FULL=${OKV}${EXTRAVERSION} 306 KV_FULL=${OKV}${EXTRAVERSION}
219 311
220 # -rc-git pulls can be achieved by specifying CKV 312 # -rc-git pulls can be achieved by specifying CKV
221 # for example: 313 # for example:
222 # CKV="2.6.11_rc3_pre2" 314 # CKV="2.6.11_rc3_pre2"
223 # will pull: 315 # will pull:
224 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2 316 # linux-2.6.10.tar.xz & patch-2.6.11-rc3.xz & patch-2.6.11-rc3-git2.xz
225 317
318 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
319
226 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then 320 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
227 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 321 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
228 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2 322 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
229 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 323 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
230 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2" 324 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
231 fi 325 fi
232 326
233 if [[ ${RELEASETYPE} == -git ]]; then 327 if [[ ${RELEASETYPE} == -git ]]; then
234 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2 328 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
235 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 329 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
236 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2" 330 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
237 fi 331 fi
238 332
239 if [[ ${RELEASETYPE} == -rc-git ]]; then 333 if [[ ${RELEASETYPE} == -rc-git ]]; then
240 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 334 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
241 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 335 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz
242 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 336 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz
243 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 337 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
338
244 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 339 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz"
245 fi 340 fi
341 else
342 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
343 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
344 OKV="2.6.39"
345 else
346 KV_PATCH_ARR=(${KV_PATCH//\./ })
347 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
348 fi
349 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
350 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
351 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
352 fi
353
354 if [[ ${RELEASETYPE} == -git ]]; then
355 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
356 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
357 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
358 fi
359
360 if [[ ${RELEASETYPE} == -rc-git ]]; then
361 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
362 OKV="2.6.39"
363 else
364 KV_PATCH_ARR=(${KV_PATCH//\./ })
365 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
366 fi
367 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz
368 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz
369 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
370
371 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz"
372 fi
373
374
375 fi
376
246 377
247 debug-print-kernel2-variables 378 debug-print-kernel2-variables
248 379
249 handle_genpatches 380 handle_genpatches
250} 381}
251 382
383# Note: duplicated in linux-info.eclass
252kernel_is() { 384kernel_is() {
253 # ALL of these should be set before we can safely continue this function. 385 # ALL of these should be set before we can safely continue this function.
254 # some of the sources have in the past had only one set. 386 # some of the sources have in the past had only one set.
255 local v n=0 387 local v n=0
256 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done 388 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
257 [[ $n -eq 1 ]] && detect_version 389 [[ $n -eq 1 ]] && detect_version
258 unset v n 390 unset v n
259 391
260 # Now we can continue 392 # Now we can continue
261 local operator test value x=0 y=0 z=0 393 local operator test value
262 394
263 case ${1} in 395 case ${1#-} in
264 lt) operator="-lt"; shift;; 396 lt) operator="-lt"; shift;;
265 gt) operator="-gt"; shift;; 397 gt) operator="-gt"; shift;;
266 le) operator="-le"; shift;; 398 le) operator="-le"; shift;;
267 ge) operator="-ge"; shift;; 399 ge) operator="-ge"; shift;;
268 eq) operator="-eq"; shift;; 400 eq) operator="-eq"; shift;;
269 *) operator="-eq";; 401 *) operator="-eq";;
270 esac 402 esac
271
272 for x in ${@}; do
273 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
274 value="${value}${x}"
275 z=$((${z} + 1))
276
277 case ${z} in
278 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
279 test="${test}${KV_MAJOR}";;
280 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
281 test="${test}${KV_MINOR}";;
282 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
283 test="${test}${KV_PATCH}";;
284 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 403 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
285 esac
286 done
287 404
288 [ ${test} ${operator} ${value} ] && return 0 || return 1 405 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
406 : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
407 [ ${test} ${operator} ${value} ]
289} 408}
290 409
291kernel_is_2_4() { 410kernel_is_2_4() {
292 kernel_is 2 4 411 kernel_is 2 4
293} 412}
299# Capture the sources type and set DEPENDs 418# Capture the sources type and set DEPENDs
300if [[ ${ETYPE} == sources ]]; then 419if [[ ${ETYPE} == sources ]]; then
301 DEPEND="!build? ( sys-apps/sed 420 DEPEND="!build? ( sys-apps/sed
302 >=sys-devel/binutils-2.11.90.0.31 )" 421 >=sys-devel/binutils-2.11.90.0.31 )"
303 RDEPEND="!build? ( >=sys-libs/ncurses-5.2 422 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
304 sys-devel/make )" 423 sys-devel/make
424 dev-lang/perl
425 sys-devel/bc )"
305 PDEPEND="!build? ( virtual/dev-manager )" 426 PDEPEND="!build? ( virtual/dev-manager )"
306 427
307 PROVIDE="virtual/linux-sources"
308 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
309
310 SLOT="${PVR}" 428 SLOT="${PVR}"
311 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel" 429 DESCRIPTION="Sources based on the Linux Kernel."
312 IUSE="symlink build" 430 IUSE="symlink build"
313 431
314 # Bug #266157, deblob for libre support 432 # Bug #266157, deblob for libre support
315 if [[ -z ${K_PREDEBLOBBED} ]] ; then 433 if [[ -z ${K_PREDEBLOBBED} ]] ; then
316 if [[ -z ${K_DEBLOB_AVAILABLE} ]] ; then 434 # Bug #359865, force a call to detect_version if needed
317 kernel_is ge 2 6 27 && \ 435 kernel_is ge 2 6 27 && \
436 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
318 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \ 437 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
319 K_DEBLOB_AVAILABLE=1 438 K_DEBLOB_AVAILABLE=1
320 fi
321 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then 439 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
322 IUSE="${IUSE} deblob" 440 IUSE="${IUSE} deblob"
323 # Reflect that kernels contain firmware blobs unless otherwise 441 # Reflect that kernels contain firmware blobs unless otherwise
324 # stripped 442 # stripped
325 LICENSE="${LICENSE} !deblob? ( freedist )" 443 LICENSE="${LICENSE} !deblob? ( freedist )"
326 444
445 if [[ -n KV_MINOR ]]; then
327 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}" 446 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
447 else
448 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
449 fi
450
451 if [[ ${KV_MAJOR} -ge 3 ]]; then
452 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
453 fi
454
328 DEBLOB_A="deblob-${DEBLOB_PV}" 455 DEBLOB_A="deblob-${DEBLOB_PV}"
456 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
329 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/" 457 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
458 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
459 if ! has "${EAPI:-0}" 0 1 ; then
460 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
461 else
462 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
463 fi
464 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
330 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}" 465 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
331 466
467 DEPEND+=" deblob? ( =dev-lang/python-2* )"
332 KERNEL_URI="${KERNEL_URI} 468 KERNEL_URI="${KERNEL_URI}
333 deblob? ( 469 deblob? (
334 ${DEBLOB_HOMEPAGE}/download/releases/LATEST-${DEBLOB_PV}.N/${DEBLOB_A} 470 ${DEBLOB_URI}
471 ${DEBLOB_CHECK_URI}
335 )" 472 )"
336 else 473 else
337 # We have no way to deblob older kernels, so just mark them as 474 # We have no way to deblob older kernels, so just mark them as
338 # tainted with non-libre materials. 475 # tainted with non-libre materials.
339 LICENSE="${LICENSE} freedist" 476 LICENSE="${LICENSE} freedist"
345 482
346 # Since we should NOT honour KBUILD_OUTPUT in headers 483 # Since we should NOT honour KBUILD_OUTPUT in headers
347 # lets unset it here. 484 # lets unset it here.
348 unset KBUILD_OUTPUT 485 unset KBUILD_OUTPUT
349 486
350 if [[ ${CTARGET} = ${CHOST} ]]; then
351 DEPEND="!virtual/os-headers"
352 PROVIDE="virtual/os-headers"
353 SLOT="0" 487 SLOT="0"
354 else
355 SLOT="${CTARGET}"
356 fi
357else 488else
358 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 489 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
359 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 490 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
360fi 491fi
361 492
417 || die "make include/linux/version.h failed" 548 || die "make include/linux/version.h failed"
418 rm -f .config >/dev/null 549 rm -f .config >/dev/null
419} 550}
420 551
421universal_unpack() { 552universal_unpack() {
553 debug-print "Inside universal_unpack"
554
555 local OKV_ARRAY
556 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
557
422 cd "${WORKDIR}" 558 cd "${WORKDIR}"
559 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
560 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.xz
561 else
423 unpack linux-${OKV}.tar.bz2 562 unpack linux-${OKV}.tar.xz
563 fi
564
424 if [[ -d "linux" ]]; then 565 if [[ -d "linux" ]]; then
566 debug-print "Moving linux to linux-${KV_FULL}"
425 mv linux linux-${KV_FULL} \ 567 mv linux linux-${KV_FULL} \
426 || die "Unable to move source tree to ${KV_FULL}." 568 || die "Unable to move source tree to ${KV_FULL}."
427 elif [[ "${OKV}" != "${KV_FULL}" ]]; then 569 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
570 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
571 [[ "${ETYPE}" = "sources" ]]; then
572 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
573 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
574 || die "Unable to move source tree to ${KV_FULL}."
575 else
576 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
428 mv linux-${OKV} linux-${KV_FULL} \ 577 mv linux-${OKV} linux-${KV_FULL} \
578 || die "Unable to move source tree to ${KV_FULL}."
579 fi
580 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
581 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
429 || die "Unable to move source tree to ${KV_FULL}." 582 || die "Unable to move source tree to ${KV_FULL}."
430 fi 583 fi
431 cd "${S}" 584 cd "${S}"
432 585
433 # remove all backup files 586 # remove all backup files
434 find . -iname "*~" -exec rm {} \; 2> /dev/null 587 find . -iname "*~" -exec rm {} \; 2> /dev/null
435 588
436 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
437 # only do this for kernel < 2.6.27 since this file does not exist in later
438 # kernels
439 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
440 then
441 sed -i \
442 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
443 "${S}"/arch/ppc/Makefile
444 else
445 sed -i \
446 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
447 "${S}"/arch/powerpc/Makefile
448 fi
449} 589}
450 590
451unpack_set_extraversion() { 591unpack_set_extraversion() {
452 cd "${S}" 592 cd "${S}"
453 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 593 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
530} 670}
531 671
532# install functions 672# install functions
533#============================================================== 673#==============================================================
534install_universal() { 674install_universal() {
535 #fix silly permissions in tarball 675 # Fix silly permissions in tarball
536 cd "${WORKDIR}" 676 cd "${WORKDIR}"
537 chown -R root:0 * >& /dev/null 677 chown -R 0:0 * >& /dev/null
538 chmod -R a+r-w+X,u+w * 678 chmod -R a+r-w+X,u+w *
539 cd ${OLDPWD} 679 cd ${OLDPWD}
540} 680}
541 681
542install_headers() { 682install_headers() {
547 if kernel_is ge 2 6 18 ; then 687 if kernel_is ge 2 6 18 ; then
548 env_setup_xmakeopts 688 env_setup_xmakeopts
549 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die 689 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
550 690
551 # let other packages install some of these headers 691 # let other packages install some of these headers
552 rm -rf "${D}"/${ddir}/sound #alsa-headers
553 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc... 692 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
554 return 0 693 return 0
555 fi 694 fi
556 695
557 # Do not use "linux/*" as that can cause problems with very long 696 # Do not use "linux/*" as that can cause problems with very long
558 # $S values where the cmdline to cp is too long 697 # $S values where the cmdline to cp is too long
559 cd "${S}" 698 pushd "${S}" >/dev/null
560 dodir ${ddir}/linux 699 dodir ${ddir}/linux
561 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die 700 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
562 rm -rf "${D}"/${ddir}/linux/modules 701 rm -rf "${D}"/${ddir}/linux/modules
563 702
564 # Handle multilib headers and crap
565 local multi_dirs="" multi_defs=""
566 case $(tc-arch-kernel) in
567 sparc64)
568 multi_dirs="sparc sparc64"
569 multi_defs="!__arch64__ __arch64__"
570 ;;
571 x86_64)
572 multi_dirs="i386 x86_64"
573 multi_defs="__i386__ __x86_64__"
574 ;;
575 ppc64)
576 multi_dirs="ppc ppc64"
577 multi_defs="!__powerpc64__ __powerpc64__"
578 ;;
579 s390x)
580 multi_dirs="s390 s390x"
581 multi_defs="!__s390x__ __s390x__"
582 ;;
583 arm)
584 dodir ${ddir}/asm 703 dodir ${ddir}/asm
585 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm 704 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
586 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
587 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
588 ;;
589 powerpc)
590 dodir ${ddir}/asm
591 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
592 if [[ -e "${S}"/include/asm-ppc ]] ; then
593 dodir ${ddir}/asm-ppc
594 cp -pPR "${S}"/include/asm-ppc/* "${D}"/${ddir}/asm-ppc
595 fi
596 ;;
597 *)
598 dodir ${ddir}/asm
599 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
600 ;;
601 esac
602 if [[ -n ${multi_dirs} ]] ; then
603 local d ml_inc=""
604 for d in ${multi_dirs} ; do
605 dodir ${ddir}/asm-${d}
606 cp -pPR "${S}"/include/asm-${d}/* "${D}"/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
607 705
608 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
609 multi_defs=${multi_defs#* }
610 done
611 create_ml_includes ${ddir}/asm ${ml_inc}
612 fi
613
614 if kernel_is 2 6; then 706 if kernel_is 2 6 ; then
615 dodir ${ddir}/asm-generic 707 dodir ${ddir}/asm-generic
616 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic 708 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
617 fi 709 fi
618 710
619 # clean up 711 # clean up
620 find "${D}" -name '*.orig' -exec rm -f {} \; 712 find "${D}" -name '*.orig' -exec rm -f {} \;
621 713
622 cd ${OLDPWD} 714 popd >/dev/null
623} 715}
624 716
625install_sources() { 717install_sources() {
626 local file 718 local file
627 719
646 echo "Please check the ebuild ChangeLog for more details." \ 738 echo "Please check the ebuild ChangeLog for more details." \
647 > "${S}"/patches.txt 739 > "${S}"/patches.txt
648 fi 740 fi
649 741
650 mv ${WORKDIR}/linux* "${D}"/usr/src 742 mv ${WORKDIR}/linux* "${D}"/usr/src
743
744 if [[ -n "${UNIPATCH_DOCS}" ]] ; then
745 for i in ${UNIPATCH_DOCS}; do
746 dodoc "${T}"/${i}
747 done
748 fi
651} 749}
652 750
653# pkg_preinst functions 751# pkg_preinst functions
654#============================================================== 752#==============================================================
655preinst_headers() { 753preinst_headers() {
714 fi 812 fi
715 813
716 # optionally display security unsupported message 814 # optionally display security unsupported message
717 # Start with why 815 # Start with why
718 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then 816 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
719 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security" 817 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security."
720 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then 818 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
721 ewarn "${PN} is UNSUPPORTED by Gentoo Security." 819 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
722 fi 820 fi
723 # And now the general message. 821 # And now the general message.
724 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then 822 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
729 827
730 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765) 828 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
731 KV_MAJOR=$(get_version_component_range 1 ${OKV}) 829 KV_MAJOR=$(get_version_component_range 1 ${OKV})
732 KV_MINOR=$(get_version_component_range 2 ${OKV}) 830 KV_MINOR=$(get_version_component_range 2 ${OKV})
733 KV_PATCH=$(get_version_component_range 3 ${OKV}) 831 KV_PATCH=$(get_version_component_range 3 ${OKV})
734 if [[ "$(tc-arch)" = "sparc" ]] \ 832 if [[ "$(tc-arch)" = "sparc" ]]; then
735 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]] 833 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
736 then 834 then
737 echo 835 echo
738 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that" 836 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
739 elog "you now need to do" 837 elog "you now need to do"
740 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-" 838 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
741 elog "instead of just" 839 elog "instead of just"
742 elog " make" 840 elog " make"
743 elog "to compile the kernel. For more information please browse to" 841 elog "to compile the kernel. For more information please browse to"
744 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765" 842 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
745 echo 843 echo
746 fi 844 fi
747} 845 fi
748
749postinst_headers() {
750 elog "Kernel headers are usually only used when recompiling your system libc, as"
751 elog "such, following the installation of newer headers, it is advised that you"
752 elog "re-merge your system libc."
753 elog "Failure to do so will cause your system libc to not make use of newer"
754 elog "features present in the updated kernel headers."
755} 846}
756 847
757# pkg_setup functions 848# pkg_setup functions
758#============================================================== 849#==============================================================
759setup_headers() { 850setup_headers() {
773 864
774# unipatch 865# unipatch
775#============================================================== 866#==============================================================
776unipatch() { 867unipatch() {
777 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE 868 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
778 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak 869 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
779 870
780 # set to a standard locale to ensure sorts are ordered properly. 871 # set to a standard locale to ensure sorts are ordered properly.
781 myLC_ALL="${LC_ALL}" 872 myLC_ALL="${LC_ALL}"
782 myLANG="${LANG}" 873 myLANG="${LANG}"
783 LC_ALL="C" 874 LC_ALL="C"
785 876
786 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 877 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
787 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 878 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
788 879
789 # We're gonna need it when doing patches with a predefined patchlevel 880 # We're gonna need it when doing patches with a predefined patchlevel
790 extglob_bak=$(shopt -p extglob)
791 shopt -s extglob 881 eshopts_push -s extglob
792 882
793 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 883 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
794 # usage can be either via an env var or by params 884 # usage can be either via an env var or by params
795 # although due to the nature we pass this within this eclass 885 # although due to the nature we pass this within this eclass
796 # it shall be by param only. 886 # it shall be by param only.
822 else 912 else
823 extention=${i/*./} 913 extention=${i/*./}
824 extention=${extention/:*/} 914 extention=${extention/:*/}
825 PIPE_CMD="" 915 PIPE_CMD=""
826 case ${extention} in 916 case ${extention} in
917 xz) PIPE_CMD="xz -dc";;
918 lzma) PIPE_CMD="lzma -dc";;
827 bz2) PIPE_CMD="bzip2 -dc";; 919 bz2) PIPE_CMD="bzip2 -dc";;
828 patch) PIPE_CMD="cat";; 920 patch) PIPE_CMD="cat";;
829 diff) PIPE_CMD="cat";; 921 diff) PIPE_CMD="cat";;
830 gz|Z|z) PIPE_CMD="gzip -dc";; 922 gz|Z|z) PIPE_CMD="gzip -dc";;
831 ZIP|zip) PIPE_CMD="unzip -p";; 923 ZIP|zip) PIPE_CMD="unzip -p";;
854 do z="${z}0"; 946 do z="${z}0";
855 done 947 done
856 PATCH_ORDER="${z}${STRICT_COUNT}" 948 PATCH_ORDER="${z}${STRICT_COUNT}"
857 949
858 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 950 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
859 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) 951 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
860 else 952 else
861 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) 953 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
862 fi 954 fi
863 fi 955 fi
864 fi 956 fi
865 done 957 done
866 958
872 done 964 done
873 965
874 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot 966 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
875 # bug #272676 967 # bug #272676
876 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then 968 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
877 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then 969 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
878 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch" 970 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
879 echo 971 echo
880 ewarn "fbcondecor currently prevents sparc/sparc64 from booting" 972 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
881 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch." 973 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
882 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details" 974 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
901 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/} 993 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
902 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/} 994 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
903 995
904 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 996 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
905 997
906 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
907 while [ ${PATCH_DEPTH} -lt 5 ]; do 998 while [ ${PATCH_DEPTH} -lt 5 ]; do
908 echo "Attempting Dry-run:" >> ${STDERR_T} 999 echo "Attempting Dry-run:" >> ${STDERR_T}
909 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T} 1000 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
910 echo "=======================================================" >> ${STDERR_T} 1001 echo "=======================================================" >> ${STDERR_T}
911 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 1002 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
1003 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH})"
912 echo "Attempting patch:" > ${STDERR_T} 1004 echo "Attempting patch:" > ${STDERR_T}
913 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T} 1005 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
914 echo "=======================================================" >> ${STDERR_T} 1006 echo "=======================================================" >> ${STDERR_T}
915 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 1007 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
916 eend 0 1008 eend 0
918 break 1010 break
919 else 1011 else
920 eend 1 1012 eend 1
921 eerror "Failed to apply patch ${i/*\//}" 1013 eerror "Failed to apply patch ${i/*\//}"
922 eerror "Please attach ${STDERR_T} to any bug you may post." 1014 eerror "Please attach ${STDERR_T} to any bug you may post."
923 die "Failed to apply ${i/*\//}" 1015 eshopts_pop
1016 die "Failed to apply ${i/*\//} on patch depth ${PATCH_DEPTH}."
924 fi 1017 fi
925 else 1018 else
926 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 1019 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
927 fi 1020 fi
928 done 1021 done
929 if [ ${PATCH_DEPTH} -eq 5 ]; then 1022 if [ ${PATCH_DEPTH} -eq 5 ]; then
930 eend 1 1023 eerror "Failed to dry-run patch ${i/*\//}"
931 eerror "Please attach ${STDERR_T} to any bug you may post." 1024 eerror "Please attach ${STDERR_T} to any bug you may post."
932 die "Unable to dry-run patch." 1025 eshopts_pop
1026 die "Unable to dry-run patch on any patch depth lower than 5."
933 fi 1027 fi
934 done 1028 done
935 done 1029 done
936 1030
937 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which 1031 # When genpatches is used, we want to install 0000_README which documents
938 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite, 1032 # the patches that were used; such that the user can see them, bug #301478.
939 # which is why I'm not taking too much time over this. 1033 if [[ ! -z ${K_WANT_GENPATCHES} ]] ; then
1034 UNIPATCH_DOCS="${UNIPATCH_DOCS} 0000_README"
1035 fi
1036
1037 # When files listed in UNIPATCH_DOCS are found in KPATCH_DIR's, we copy it
1038 # to the temporary directory and remember them in UNIPATCH_DOCS to install
1039 # them during the install phase.
940 local tmp 1040 local tmp
1041 for x in ${KPATCH_DIR}; do
941 for i in ${UNIPATCH_DOCS}; do 1042 for i in ${UNIPATCH_DOCS}; do
1043 if [[ -f "${x}/${i}" ]] ; then
942 tmp="${tmp} ${i//*\/}" 1044 tmp="${tmp} ${i}"
943 cp -f ${i} "${T}"/ 1045 cp -f "${x}/${i}" "${T}"/
1046 fi
1047 done
944 done 1048 done
945 UNIPATCH_DOCS="${tmp}" 1049 UNIPATCH_DOCS="${tmp}"
946 1050
947 # clean up KPATCH_DIR's - fixes bug #53610 1051 # clean up KPATCH_DIR's - fixes bug #53610
948 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 1052 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
949 1053
950 LC_ALL="${myLC_ALL}" 1054 LC_ALL="${myLC_ALL}"
951 LANG="${myLANG}" 1055 LANG="${myLANG}"
952 eval ${extglob_bak} 1056 eshopts_pop
953} 1057}
954 1058
955# getfilevar accepts 2 vars as follows: 1059# getfilevar accepts 2 vars as follows:
956# getfilevar <VARIABLE> <CONFIGFILE> 1060# getfilevar <VARIABLE> <CONFIGFILE>
957# pulled from linux-info 1061# pulled from linux-info
1004 for i in ${COMPAT_URI}; do 1108 for i in ${COMPAT_URI}; do
1005 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}" 1109 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
1006 done 1110 done
1007 fi 1111 fi
1008 done 1112 done
1009}
1010
1011# sparc nastiness
1012#==============================================================
1013# This script generates the files in /usr/include/asm for sparc systems
1014# during installation of sys-kernel/linux-headers.
1015# Will no longer be needed when full 64 bit support is used on sparc64
1016# systems.
1017#
1018# Shamefully ripped from Debian
1019# ----------------------------------------------------------------------
1020
1021# Idea borrowed from RedHat's kernel package
1022
1023# This is gonna get replaced by something in multilib.eclass soon...
1024# --eradicator
1025generate_sparc_asm() {
1026 local name
1027
1028 cd $1 || die
1029 mkdir asm
1030
1031 for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
1032 name="$(echo $h | tr a-z. A-Z_)"
1033 # common header
1034 echo "/* All asm/ files are generated and point to the corresponding
1035 * file in asm-sparc or asm-sparc64.
1036 */
1037
1038#ifndef __SPARCSTUB__${name}__
1039#define __SPARCSTUB__${name}__
1040" > asm/${h}
1041
1042 # common for sparc and sparc64
1043 if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
1044 echo "#ifdef __arch64__
1045#include <asm-sparc64/$h>
1046#else
1047#include <asm-sparc/$h>
1048#endif
1049" >> asm/${h}
1050
1051 # sparc only
1052 elif [ -f asm-sparc/$h ]; then
1053echo "#ifndef __arch64__
1054#include <asm-sparc/$h>
1055#endif
1056" >> asm/${h}
1057
1058 # sparc64 only
1059 else
1060echo "#ifdef __arch64__
1061#include <asm-sparc64/$h>
1062#endif
1063" >> asm/${h}
1064 fi
1065
1066 # common footer
1067 echo "#endif /* !__SPARCSTUB__${name}__ */" >> asm/${h}
1068 done
1069 return 0
1070} 1113}
1071 1114
1072headers___fix() { 1115headers___fix() {
1073 # Voodoo to partially fix broken upstream headers. 1116 # Voodoo to partially fix broken upstream headers.
1074 # note: do not put inline/asm/volatile together (breaks "inline asm volatile") 1117 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1116 kernel_is 2 4 && unpack_2_4 1159 kernel_is 2 4 && unpack_2_4
1117 kernel_is 2 6 && unpack_2_6 1160 kernel_is 2 6 && unpack_2_6
1118 fi 1161 fi
1119 1162
1120 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then 1163 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1121 cp "${DISTDIR}/${DEBLOB_A}" "${T}" 1164 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1122 chmod +x "${T}/${DEBLOB_A}" 1165 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1166 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1167 fi
1168
1169 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
1170 # only do this for kernel < 2.6.27 since this file does not exist in later
1171 # kernels
1172 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
1173 then
1174 sed -i \
1175 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1176 "${S}"/arch/ppc/Makefile
1177 else
1178 sed -i \
1179 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1180 "${S}"/arch/powerpc/Makefile
1123 fi 1181 fi
1124} 1182}
1125 1183
1126kernel-2_src_compile() { 1184kernel-2_src_compile() {
1127 cd "${S}" 1185 cd "${S}"
1128 [[ ${ETYPE} == headers ]] && compile_headers 1186 [[ ${ETYPE} == headers ]] && compile_headers
1129 1187
1130 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then 1188 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1131 echo ">>> Running deblob script ..." 1189 echo ">>> Running deblob script ..."
1132 sh "${T}/${DEBLOB_A}" --force || \ 1190 EPYTHON="python2" sh "${T}/${DEBLOB_A}" --force || die "Deblob script failed to run!!!"
1133 die "Deblob script failed to run!!!"
1134 fi 1191 fi
1135} 1192}
1193
1194# if you leave it to the default src_test, it will run make to
1195# find whether test/check targets are present; since "make test"
1196# actually produces a few support files, they are installed even
1197# though the package is binchecks-restricted.
1198#
1199# Avoid this altogether by making the function moot.
1200kernel-2_src_test() { :; }
1136 1201
1137kernel-2_pkg_preinst() { 1202kernel-2_pkg_preinst() {
1138 [[ ${ETYPE} == headers ]] && preinst_headers 1203 [[ ${ETYPE} == headers ]] && preinst_headers
1139} 1204}
1140 1205
1143 [[ ${ETYPE} == headers ]] && install_headers 1208 [[ ${ETYPE} == headers ]] && install_headers
1144 [[ ${ETYPE} == sources ]] && install_sources 1209 [[ ${ETYPE} == sources ]] && install_sources
1145} 1210}
1146 1211
1147kernel-2_pkg_postinst() { 1212kernel-2_pkg_postinst() {
1148 [[ ${ETYPE} == headers ]] && postinst_headers
1149 [[ ${ETYPE} == sources ]] && postinst_sources 1213 [[ ${ETYPE} == sources ]] && postinst_sources
1150} 1214}
1151 1215
1152kernel-2_pkg_setup() { 1216kernel-2_pkg_setup() {
1153 if kernel_is 2 4; then 1217 if kernel_is 2 4; then
1154 if [ "$( gcc-major-version )" -eq "4" ] ; then 1218 if [[ $(gcc-major-version) -ge 4 ]] ; then
1155 echo 1219 echo
1156 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!" 1220 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1157 ewarn "Either switch to another gcc-version (via gcc-config) or use a" 1221 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1158 ewarn "newer kernel that supports gcc-4." 1222 ewarn "newer kernel that supports gcc-4."
1159 echo 1223 echo
1166 1230
1167 ABI="${KERNEL_ABI}" 1231 ABI="${KERNEL_ABI}"
1168 [[ ${ETYPE} == headers ]] && setup_headers 1232 [[ ${ETYPE} == headers ]] && setup_headers
1169 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1233 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
1170} 1234}
1235
1236kernel-2_pkg_postrm() {
1237 # This warning only makes sense for kernel sources.
1238 [[ ${ETYPE} == headers ]] && return 0
1239
1240 # If there isn't anything left behind, then don't complain.
1241 [[ -e ${ROOT}usr/src/linux-${KV_FULL} ]] || return 0
1242 echo
1243 ewarn "Note: Even though you have successfully unmerged "
1244 ewarn "your kernel package, directories in kernel source location: "
1245 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1246 ewarn "with modified files will remain behind. By design, package managers"
1247 ewarn "will not remove these modified files and the directories they reside in."
1248 echo
1249}

Legend:
Removed from v.1.232  
changed lines
  Added in v.1.285

  ViewVC Help
Powered by ViewVC 1.1.20